<html>
<head>
<title>OGRE: OgreShadowCameraSetupLiSPSM.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreShadowCameraSetupLiSPSM.h</h1><a href="OgreShadowCameraSetupLiSPSM_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2006 Matthias Fink, netAllied GmbH &lt;matthias.fink@web.de&gt;                             </span>
<a name="l00009"></a>00009 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00010"></a>00010 <span class="comment"></span>
<a name="l00011"></a>00011 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00012"></a>00012 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00013"></a>00013 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00014"></a>00014 <span class="comment">version.</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00017"></a>00017 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00018"></a>00018 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00021"></a>00021 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00022"></a>00022 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00023"></a>00023 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00024"></a>00024 <span class="comment"></span>
<a name="l00025"></a>00025 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00026"></a>00026 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00027"></a>00027 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00028"></a>00028 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00029"></a>00029 <span class="comment">*/</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __ShadowCameraSetupLiSPSM_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCameraSetupLiSPSM_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreShadowCameraSetupFocused_8h.html">OgreShadowCameraSetupFocused.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre 
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00093"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html">00093</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html" title="Implements the uniform shadow mapping algorithm in focused mode.">FocusedShadowCameraSetup</a>
<a name="l00094"></a>00094     {
<a name="l00095"></a>00095     <span class="keyword">protected</span>:
<a name="l00097"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#ae134702a175b3f5048364a6e44a0a12">00097</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mOptAdjustFactor;
<a name="l00099"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#10db7404fd7ff4b65920f35a1e7412d9">00099</a>         <span class="keywordtype">bool</span> mUseSimpleNOpt;
<a name="l00100"></a>00100 
<a name="l00116"></a>00116         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> calculateLiSPSM(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> PointListBody&amp; bodyB, 
<a name="l00117"></a>00117             <span class="keyword">const</span> PointListBody&amp; bodyLVS, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>&amp; sm, 
<a name="l00118"></a>00118             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00144"></a>00144         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculateNOpt(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bodyBABB_ls, 
<a name="l00145"></a>00145             <span class="keyword">const</span> PointListBody&amp; bodyLVS, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam) <span class="keyword">const</span>;
<a name="l00146"></a>00146 
<a name="l00149"></a>00149         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculateNOptSimple(<span class="keyword">const</span> PointListBody&amp; bodyLVS, 
<a name="l00150"></a>00150             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00162"></a>00162         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> calculateZ0_ls(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; e, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bodyB_zMax_ls, 
<a name="l00163"></a>00163             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam) <span class="keyword">const</span>;
<a name="l00164"></a>00164 
<a name="l00170"></a>00170         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> buildFrustumProjection(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, 
<a name="l00171"></a>00171             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> near, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> far) <span class="keyword">const</span>;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     <span class="keyword">public</span>:
<a name="l00178"></a>00178         <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a>(<span class="keywordtype">void</span>);
<a name="l00179"></a>00179 
<a name="l00184"></a>00184         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a>(<span class="keywordtype">void</span>);
<a name="l00185"></a>00185 
<a name="l00192"></a>00192         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getShadowCamera(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a> *sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *cam, 
<a name="l00193"></a>00193             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> *light, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *texCam) <span class="keyword">const</span>;
<a name="l00194"></a>00194 
<a name="l00207"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a4f0c58ca0ea89aa7e4b11def4976ea6">00207</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOptimalAdjustFactor(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> n) { mOptAdjustFactor = n; }
<a name="l00211"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#af7b2c705eff6b04d001279e7ad5b846">00211</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOptimalAdjustFactor()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOptAdjustFactor; }
<a name="l00215"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#e09cafbe81832dd23c70f85d9435b213">00215</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setUseSimpleOptimalAdjust(<span class="keywordtype">bool</span> s) { mUseSimpleNOpt = s; }
<a name="l00219"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#8fc373347be0c44cc787ff984e3a861f">00219</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getUseSimpleOptimalAdjust()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseSimpleNOpt; }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221     };
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
